/*  Copyright(C) 2008 PaulLiu(Ying-Chun Liu). All rights reserved.
 *
 *  This file is subject to the terms and conditions of the GNU General Public
 *  License. See the file gpl.txt for more details.
 *
*/

#ifndef PaulLiu_HEADER_Common_235124124
#define PaulLiu_HEADER_Common_235124124

#define TRANSTABLE1MAXSIZE 512
#define KEYARRAYSIZE 128

#include <string>

enum keyevent_type
{
  KEYEVENT_PRESS, KEYEVENT_RELEASE, KEYEVENT_ACCUMULATION
};

struct keyevent
{
  enum keyevent_type type;
  int key;
  int keyarray[KEYARRAYSIZE];
  int keyarray_count;
};

enum inputmode
{
  INPUTMODE_ISO8859_1, INPUTMODE_BIG5, INPUTMODE_NORMAL, INPUTMODE_LIU
};
/* main */
int toprintfstring (char *);
/* eventgen */
int readscancode(void);
int iohandler(void);
int reverse_scancode (const char *);
int genarray (const char *, int *);
/* normal key */
int normalhandler (const struct keyevent *ev);
int isnormalkey(int);
/* sound effect */
int loadsoundfile (void);
int playsound (std::string);
/* iso8859-1 handler */
int readiso8859table1(void);
int iso8859_event_handler(const struct keyevent *);
/* big5 handler */
int loadbig5table (void);
int loadliutable (void);
int big5_event_handler(const struct keyevent *);
int liu_event_handler(const struct keyevent *);

/* linux */
int linux_init(void);
int input_event(struct input_event *event);
int output_event(const struct input_event *event);
int output_string(const char *c);
int getleds(void);

#endif
