/*  brlkey
    Copyright(C) 2008 PaulLiu(Ying-Chun Liu). All rights reserved.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <config.h>
#include <iostream>
#include <map>
#include <fstream>
#include <string>

#include <cstdio>
#include <cstring>
#include <linux/input.h>
#include <linux/kd.h>

#include "common.h"

using namespace std;

int
normalhandler (const struct keyevent *ev)
{
  int leds = getleds();
  if (ev->type == KEYEVENT_RELEASE)
    return 0;
  switch (ev->key) {
    case KEY_CAPSLOCK:
      if (!(leds & LED_CAP))
	  playsound("tobig5");
      else
	  playsound("toenglish");
      return 0;
    case KEY_NUMLOCK:
      if (!(leds & LED_NUM))
	  playsound("tobig5");
      else
	  playsound("toenglish");
      return 0;
    case KEY_SCROLLLOCK:
      if (!(leds & LED_SCR))
	  playsound("tobig5");
      else
	  playsound("toenglish");
      return 0;
  }
  return 0;
}

int
isnormalkey (int now)
{
  if ((KEY_A <= now && now <= KEY_F) || (KEY_J <= now && now <= KEY_M) || (now == KEY_SPACE))
    return 0;
  return 1;
}
